hsc3 - haskell supercollider
----------------------------

[hsc3](http://rohandrape.net/?t=hsc3)
provides `Sound.SC3`, a module for using
[Haskell](http://haskell.org/)
as a client to the
[SuperCollider](http://audiosynth.com/)
synthesis server.
hsc3 requires
[hosc](http://rohandrape.net/?t=hosc).

There is an
[introduction](http://rohandrape.net/?t=hsc3-texts&e=lhs/hsc3-introduction.lhs)
and a
[tutorial](http://rohandrape.net/?t=hsc3-texts&e=lhs/hsc3-tutorial.lhs)
at
[hsc3-texts](http://rohandrape.net/?t=hsc3-texts).

There are a number of related projects:

- [sc3-rdu](http://rohandrape.net/?t=sc3-rdu): SuperCollider UGens (1998)
- [rsc3](http://rohandrape.net/?t=rsc3): Scheme SuperCollider (2004)
- [hsc3-dot](http://rohandrape.net/?t=hsc3-dot): UGen graph drawing (2006)
- [hsc3-graphs](http://rohandrape.net/?t=hsc3-graphs): UGen graph collection (2006)
- [hsc3-db](http://rohandrape.net/?t=hsc3-db): UGen Database (2006)
- [hsc3-sf](http://rohandrape.net/?t=hsc3-sf): Sound file IO (2006)
- [hsc3-unsafe](http://rohandrape.net/?t=hsc3-unsafe): Unsafe UGen variants (2006)
- [hsc3-lang](http://rohandrape.net/?t=hsc3-lang): SC3 language (2007)
- [hsc3-rec](http://rohandrape.net/?t=hsc3-rec): Record UGens (2008)
- [smlsc3](http://rohandrape.net/?t=smlsc3): Standard ML SuperCollider (2008)
- [hsc3-sf-hsndfile](http://rohandrape.net/?t=hsc3-sf-hsndfile): Sound file IO (libsndfile) (2010)
- [hsc3-auditor](http://rohandrape.net/?t=hsc3-auditor): Simple sound event auditioner (2010)
- [hsc3-cairo](http://rohandrape.net/?t=hsc3-cairo): Drawing (2012)
- [hsc3-plot](http://rohandrape.net/?t=hsc3-plot): Plotting (2013)
- [hsc3-data](http://rohandrape.net/?t=hsc3-data): Data formats &etc. (2013)
- [hsc3-rw](http://rohandrape.net/?t=hsc3-rw): UGen Graph Re-writing (2013)
- [hsc3-forth](http://rohandrape.net/?t=hsc3-forth): Forth SuperCollider (2014)
- [hsc3-lisp](http://rohandrape.net/?t=hsc3-lisp): Lisp SuperCollider (2014)
- [hsc3-m](http://rohandrape.net/?t=hsc3-m): UGen variants (2018)
- [stsc3](http://rohandrape.net/?t=stsc3): Smalltalk SuperCollider (2019)
- [hsc3-util](http://rohandrape.net/?t=hsc3-util): hsc3 & related utilities (2020)

The hsc3 interaction environment ([hsc3.el](http://rohandrape.net/?t=hsc3&e=emacs/hsc3.el))
is written for
[GNU](http://gnu.org/)
[Emacs](http://gnu.org/software/emacs/).

<!--
There is also, more obliquely related:
-->

## help

[UGen Index](http://rohandrape.net/?t=hsc3&e=Help/UGen/ix.md)

©
[rohan drape](http://rohandrape.net/)
and others, 2005-2022,
[gpl-3](http://gnu.org/copyleft/)

with contributions by:

- henning thielemann
- stefan kersten
- alex mclean
- brent yorgey
- shae erisson

see the
[git](https://git-scm.com/)
[history](http://rohandrape.net/?t=hsc3&q=history)
for details

initial announcement:
[[2005-11-29/haskell-cafe](http://rohandrape.net/?t=hsc3&e=md/announce.text),
 [haskell.org](http://www.haskell.org/pipermail/haskell-cafe/2005-November/012483.html)]
